#include "PartEmitter.h"
#include <stdio.h>
#include "particle.h"

float CPartEmitter::m_fFrameTime = 0.0f;
float CPartEmitter::m_fCurTime	 = 0.0f;


CPartEmitter::CPartEmitter(int iMaxParticles)
{
	m_ParticleList.Clear();
	m_iMaxParticles = iMaxParticles;
	m_iNumParticles = 0;
}

CPartEmitter::~CPartEmitter()
{
	// falls die Partikelliste nicht leer ist, werden alle brigen Elemente gelscht
	CParticle* pPar = m_ParticleList.GetHead();
	CParticle* pNext = NULL;
	while(pPar)
	{
		pNext = pPar->GetNext();
		delete pPar;
		pPar = NULL;
		pPar = pNext;
	}
	m_ParticleList.Clear();
}

bool CPartEmitter::Add(CParticle* pParticle)
{
	// falls die maximale Anzahl von Partikeln noch nicht erreicht wurde, wird der Liste
	// eine Partikel hinzugefgt und true zurckgegeben
	if(m_iNumParticles < m_iMaxParticles)
	{
		m_ParticleList.Add(pParticle);
		m_iNumParticles++;
		return true;
	}

	// ansonsten wird false zurckgegeben
	return false;
}

void CPartEmitter::Update()
{
	// Schleife durch alle Partikel der Liste
	CParticle* pPar = m_ParticleList.GetHead();
	CParticle* pPrev = NULL;
	while(pPar)
	{
		pPar->Update(); // Update des Partikels

		if(!pPar->m_bLife)	// falls der Partikel nicht mehr lebt
		{
			// Partikel wird aus Liste entfernt und gelscht
			if(pPrev)
				pPrev->SetNext(pPar->GetNext());
			else
				m_ParticleList.SetHead(pPar->GetNext()); 

			delete pPar; pPar = NULL;
			m_iNumParticles--;
			
			if(pPrev)
				pPar = pPrev->GetNext();
			else
				pPar = m_ParticleList.GetHead();
			
			continue;
		} else	
		{
			// falls der Partikel noch lebt, wird er gerendert					
			pPar->Render();
		}
		
		pPrev = pPar;
		pPar = pPar->GetNext();
	}

}
