#ifndef PARTICLE_H
#define PARTICLE_H

#include "list.h"

typedef float VECTOR[3];

class CPartEmitter;

class CParticle  
{
public:
	CParticle(CPartEmitter* pEmitter);
	virtual ~CParticle();
	void Update();
	void Render();
public:
	VECTOR m_vPosition;		// Position
	VECTOR m_vVelocity;		// Geschwindigkeit
	float	 m_clrColor[4];	// Farbe
	float	 m_fSize;				// Groesse
	float  m_fBirthday;		// Zeitpunkt der Geburt
	float  m_fLifetime;		// Lebenspanne
	bool	 m_bLife;				// wird vom Emitter gelscht falls false
	void Set(VECTOR vPosition,VECTOR vVelocity,float clrColor[4],float fSize,float fLifetime);
	CParticle* GetNext();
	void SetNext(CParticle* pNext);
private:
	CPartEmitter* m_pEmitter;
	CParticle* m_pNext;
};

class	CParticleList : public CList<CParticle*> {};

inline CParticle* CParticle::GetNext() {return m_pNext;}
inline void CParticle::SetNext(CParticle* pNext) {m_pNext = pNext;}


#endif // PARTICLE_H
