//------------------------------------------------------------------------
//- Info --
//- Dieses Template dient als Basisklasse fr einfach verkettete Listen
//- Erstellungsdatum: 15.01.01 -- Autor: Tobias Rick --
//- letzte nderung:	31.12.01
//------------------------------------------------------------------------
#ifndef LIST_H
#define LIST_H

#include <stdio.h>

template<class TYPE> class CList
{
public:
	CList();

	void	Add(TYPE pNewElement);
	TYPE GetHead();
	TYPE GetTail();

	void SetHead(TYPE pNewHead);

	bool IsEmpty();
	void Clear();
private:
	TYPE m_pHead;
	TYPE m_pTail;
};

template<class TYPE> inline bool CList<TYPE>::IsEmpty()
{ return m_pHead == NULL ? true : false; }

template<class TYPE> inline void CList<TYPE>::Clear()
{ m_pHead = NULL; m_pTail = NULL;}

template<class TYPE> inline TYPE CList<TYPE>::GetHead() { return m_pHead; }

template<class TYPE> inline TYPE CList<TYPE>::GetTail() { return m_pTail; }

template<class TYPE> CList<TYPE>::CList() {	m_pHead = m_pTail = NULL; }

template<class TYPE> void CList<TYPE>::SetHead(TYPE pNewHead)
{
	if(m_pHead == m_pTail)
	{
		m_pHead = pNewHead;
		m_pTail = pNewHead;
	} else
		m_pHead = pNewHead;
}

template<class TYPE> void CList<TYPE>::Add(TYPE pNewElement)
{
	if (m_pHead == NULL)
	{
		m_pHead = m_pTail = pNewElement;
	}
	else if((m_pHead != NULL) && (m_pHead == m_pTail))
	{
		pNewElement->SetNext( NULL );
		m_pHead->SetNext(pNewElement);
		m_pTail	= pNewElement;
	}
	else
	{
		pNewElement->SetNext( NULL );
		m_pTail->SetNext(pNewElement);
		m_pTail = pNewElement;
	}
}

#endif // LIST_H